Import mojo

Global J_Red#,J_Green#,J_Blue#,J_Alpha#
Global J_CLS_Red#,J_CLS_Green#,J_CLS_Blue#
Global J_ScaleX#,J_ScaleY#,J_Rotate#
Global JFont

Global FadeIn#,FadeOut#,Drop#,LoaderPause
Global jscrw#=800
Global jscrh#=600
Global myscrw#,myscrh#,aimscrw#,aimscrh#
Global OriginX#,OriginY#,OriginZ#,OriginZX#,fla,flb
Global menux#,menuy#,menux2#,menuy2#,MenuIn#,menuR#,menuG#,menuB#
Global scrx#,scry#

Global GameMode=0,Loader=1,GameHasPlayed,GameType=0
Global a,b,c,d,i,j,k,m,n,x,y,z,ttxt$
Global img:Image[1024],fnt:Image[50],sfx:Sound[1024]
Global mx#,my#,mudown,md,md2

Global Dead=0

Global LastFrame,LastFrameb,GameSpeed
Global Score

Global Highscore[30]
Global Settings[10]

Global EndofGame,EndofGameStall

Function SetResolution(fw,fh)
aimscrw=fw	aimscrh=fh
End

Function Device()	
	myscrw=DeviceWidth()
	myscrh=DeviceHeight()

	OriginZ=myscrw/aimscrw
	OriginZX=myscrh/aimscrh
	If OriginZX>OriginZ Then OriginZ=OriginZX
	

	fla=((aimscrw/2)*OriginZ)
	flb=myscrw/2
	OriginX=0'(flb-fla)/2
	
	fla=((aimscrh/2)*OriginZ)
	flb=myscrh/2
	OriginY=0'(flb-fla)/2

	jscrw=(myscrw/OriginZ)
	jscrh=(myscrh/OriginZ)

#If TARGET="android" Or TARGET="ios" Then
	mx=((TouchX())/OriginZ)-OriginX
	my=((TouchY())/OriginZ)-OriginY
	md=TouchDown()
#Else
	mx=((MouseX())/OriginZ)-OriginX
	my=((MouseY())/OriginZ)-OriginY
	md=MouseDown()
	md2=MouseDown(MOUSE_RIGHT)
#EndIf

End Function

Function ResetDraw()
	J_Red=255
	J_Green=255
	J_Blue=255
	SetColor 255,255,255
	J_Alpha=1
	SetAlpha 1
	J_ScaleX=1
	J_ScaleY=1
	J_Rotate=0
End

Function SetSize(fx#,fy#=-37171650)
	J_ScaleX=fx	J_ScaleY=fx
	If fy>-37171650 Then J_ScaleY=fy
End

Function SetRot(fn#)
	J_Rotate=fn
End

Function SetCLSCol(Fr,Fg,Fb)
	J_CLS_Red=Fr
	J_CLS_Green=Fg
	J_CLS_Blue=Fb
End

Function SetCol(Fr#,Fg#,Fb#,Falpha#=-37171650)
	J_Red=Fr
	J_Green=Fg
	J_Blue=Fb
	SetColor Fr,Fg,Fb
	If Falpha>-37171650
		J_Alpha=Falpha
		SetAlpha Falpha
	End
End

Function Alpha(Falpha#)
	J_Alpha=Falpha
	SetAlpha Falpha
End

Function CLS3D(do=1)
	ResetDraw
	If do=1 Then Cls(J_CLS_Red,J_CLS_Green,J_CLS_Blue)
	ResetDraw
End


Function Rect(fx#,fy#,fw#,fh#,midX=0,midY=0)
	Scale OriginZ*J_ScaleX,OriginZ*J_ScaleY
		DrawRect(fx+OriginX-((fw/2)*midX),fy+OriginY-((fh/2)*midY),fw,fh)
	Scale 1/(OriginZ*J_ScaleX),1/(OriginZ*J_ScaleY)
End Function

Function Oval(fx#,fy#,fw#,fh#,midX=0,midY=0)
	Scale OriginZ*J_ScaleX,OriginZ*J_ScaleY
		DrawOval(fx+OriginX-((fw/2)*midX),fy+OriginY-((fh/2)*midY),fw,fh)
	Scale 1/(OriginZ*J_ScaleX),1/(OriginZ*J_ScaleY)
End Function

Function DrawImg(img:Image,fx#,fy#,frame=0,midX=0,midY=0)
midX=midX-1	midY=midY-1
	Local fw#=img.Width()*J_ScaleX
	Local fh#=img.Height()*J_ScaleY
	fx=fx-(((fw/2)*midX))
	fy=fy-(((fh/2)*midY))
	
	fx=fx*OriginZ
	fy=fy*OriginZ
		DrawImage(img,(fx+OriginX),(fy+OriginY),-J_Rotate,OriginZ*J_ScaleX,OriginZ*J_ScaleY,frame)
End


Function LoadFont(fn,ftxt$)
	Local bracketl,bracketr,midx,wtxt$,htxt$,ftxt2$
	bracketl=ftxt.FindLast("(")
	bracketr=ftxt.FindLast(")")
	midx=ftxt.FindLast("x")
	wtxt=ftxt[(bracketl+1)..(midx)]
	htxt=ftxt[(midx+1)..(bracketr)]
	fla=Int(wtxt)	flb=Int(htxt)
	fnt[fn]=LoadImage(ftxt,fla,flb,256)
	bracketr=ftxt.FindLast(".png")
	ftxt2=ftxt[..(bracketr)]+"_dark.png"
	Cls(0,0,0)
	Text 1,1,ftxt+"!"
	Text 1,40,ftxt2+"!"
	Text 1,80,wtxt+":"+htxt	
	fnt[fn+25]=LoadImage(ftxt2,fla,flb,256)
End
Function UseFont(fn,dark=0)
	JFont=fn
	SetFont fnt[fn+(dark*25)]
End
Function Text(fx#,fy#,ftxt$,midX#=0,midY#=0)
	Local fw#=TextWidth(ftxt)*J_ScaleX
	Local fh#=TextHeight()*J_ScaleY
	If midX>0 Then fx=fx-(((fw/2)*midX))
	If midY>0 Then fy=fy-(((fh/2)*midY))
	fx=fx/J_ScaleX
	fy=fy/J_ScaleY
	
	Scale OriginZ*J_ScaleX,OriginZ*J_ScaleY
		DrawText(ftxt,fx+(OriginX),fy+(OriginY),0,0)
	Scale 1/(OriginZ*J_ScaleX),1/(OriginZ*J_ScaleY)
End

Function ShadowText(fx#,fy#,ftxt$,midX#=0,midY#=0,fd#=2)
	SetColor 0,0,0
	SetAlpha .8
	UseFont(JFont,1)
	Text(fx+fd,fy+fd,ftxt,midX,midY)
	
	SetColor J_Red,J_Green,J_Blue
	SetAlpha J_Alpha
	UseFont(JFont)
	Text(fx,fy,ftxt,midX,midY)
End


Function Scores()
	Local did=0
	For a=0 To 9
		If Score>Highscore[a+(GameType*10)] And did=0
			For b=9 To a+1 Step -1
				Highscore[b+(GameType*10)]=Highscore[(b-1)+(GameType*10)]
			Next
			Highscore[(a)+(GameType*10)]=Score
			did=1
		End
	Next
End

Function SaveGame()
	ttxt=""
	For n=0 To 9
		ttxt=ttxt+Highscore[n]+"|"
	Next
	For n=0 To 9
		ttxt=ttxt+Highscore[n+10]+"|"
	Next
	For n=0 To 9
		ttxt=ttxt+Highscore[n+20]+"|"
	Next
	For n=0 To 9
		ttxt=ttxt+Settings[n]+"|"
	Next
	SaveState(ttxt)
End

Function LoadGame()
	Local chunks$[20]
	ttxt=LoadState()
	If ttxt.Find("|")>0
		chunks=ttxt.Split("|")
		For n=0 To 9
			Highscore[n]=Int(chunks[n]) If Highscore[n]="NaN" Then Highscore[n]=0
			Highscore[n+10]=Int(chunks[n+10]) If Highscore[n+10]="NaN" Then Highscore[n+10]=0
			Highscore[n+20]=Int(chunks[n+20]) If Highscore[n+20]="NaN" Then Highscore[n+20]=0	
			Settings[n]=Int(chunks[n+30]) If Settings[n]="NaN" Then Settings[n]=0
		Next
	End
End

Function Rand(max#)
	Return Floor(Rnd(0,max+.999))
End
Function Rand(min#,max#)
	Return Floor(Rnd(min,max+.999))
End
Function SeedRnd(fn)
	For fla=1 To 5	flb=Rnd(5)	Next
	Seed=fn
End Function

Function Mousein(fx,fy,fw,fh)
	Return (mx>fx-1 And my>fy-1 And mx<fx+fw And my<fy+fh)
End
Function mousein(fx,fy,fw,fh)
	Return (mx>fx-1 And my>fy-1 And mx<fx+fw And my<fy+fh)
End
Function MouseIn(fx,fy,fw,fh)
	Return (mx>fx-1 And my>fy-1 And mx<fx+fw And my<fy+fh)
End


Function Button(fb,ftxt$,fx,fy)
	SetCol 0,0,80,.4
	Local fw=TextWidth(ftxt)+32
	Local fh=TextHeight()+32
	If GameType=fb Then SetCol 0,255,0,.6
	
	
	Rect fx-42,fy-26,84,52
	
	SetCol 255,255,255,1
	ShadowText fx,fy,ftxt,1,1
	
	DrawImg img[1021],fx,fy,0,1,1
	
	Local tap=0
	If Mousein(fx-(fw/2),fy-(fh/2),fw,fh) And md=1 And mudown=0 Then tap=1
	If tap=1 And GameType<>fb Then tap=0	mudown=1	GameType=fb
	Return tap
End